include \masm32\include\masm32rt.inc
.686
include timers.asm

include fsAlloc.asm

ALLOC_SIZE	equ	1000	; be smart and choose multiples of four :P

debug macro params:vararg
	pushfd
	pushad
	% print params
	popad
	popfd
endm

.data

hheap		dd	0

.code


; benchmark results:
; 4 bytes
;		alloc: 6
;		alloc + free: 3
;	16 bytes
;		alloc: 20
;		alloc + free: 3
;		heap alloc: 359
;		heap alloc + free: 220
; 32 bytes
;		alloc: 42
;		alloc + free: 3
;		heap alloc: 380
;		heap alloc + free: 220
;	64 bytes
;		alloc: 85
;		alloc + free: 3
;		heap alloc: 440
;		heap alloc + free: 220
; 128 bytes
;		alloc: 115
;		alloc + free: 3
;		heap alloc: 555
;		heap alloc + free: 220
;	256 bytes
;		alloc: 168
;		alloc + free: 3
; 512 bytes
;		alloc: 270
;		alloc + free: 3
; 1024 bytes
;		alloc: 465
;		alloc + free: 3
; 2048 bytes
;		alloc: 884
;		alloc + free: 3
;
; some odd sizes:
; 1000 bytes
;		alloc: 460
;		alloc + free: 3
;	124 bytes
;		alloc: 128
;		alloc + free: 3
;	1244 bytes
;		alloc: 570
;		alloc + free: 3

start:
	counter_begin 100000, HIGH_PRIORITY_CLASS
	fsAlloc 1000;%ALLOC_SIZE
	mov dword ptr [eax], 0
	counter_end
	debug "fsAlloc "
	debug <ustr$(ALLOC_SIZE)>
	debug ": "
	debug <ustr$(eax)>, 10
	
	counter_begin 100000, HIGH_PRIORITY_CLASS
	fsAlloc 1000;%ALLOC_SIZE
	mov dword ptr [eax], 0
	fsFree eax, 1000;%ALLOC_SIZE
	counter_end
	debug "fsAlloc/fsFree "
	debug <ustr$(ALLOC_SIZE)>
	debug ": "
	debug <ustr$(eax)>, 10
	
	fsReleaseAll %ALLOC_SIZE
	
;	call GetProcessHeap
;	mov hheap, eax
;	
;	counter_begin 100000, HIGH_PRIORITY_CLASS
;	push ALLOC_SIZE
;	push 0
;	push hheap
;	call HeapAlloc
;	counter_end
;	debug "HeapAlloc "
;	debug <ustr$(ALLOC_SIZE)>
;	debug ": "
;	debug <ustr$(eax)>, 10
;	
;	counter_begin 100000, HIGH_PRIORITY_CLASS
;	push ALLOC_SIZE
;	push 0
;	push hheap
;	call HeapAlloc
;	push eax
;	push 0
;	push hheap
;	call HeapFree
;	counter_end
;	debug "HeapAlloc/Free "
;	debug <ustr$(ALLOC_SIZE)>
;	debug ": "
;	debug <ustr$(eax)>, 10
	
	inkey
	exit
	
end start
